// The data set is a sample from the cars data set we've seen in class
var data = {
    "Country":      ["U.S.","U.S.","Japan","Japan","Germany","Sweden","Sweden","France","Italy"],
    "Car":          ["Buick Estate Wagon","Ford Country Squire Wagon","Toyota Corona","Datsun 510","Audi 5000","Volvo 240 GL","Saab 99 GLE","Peugeot 694 SL","Fiat Strada"],
    "Mpg":          [16.9,15.5,27.5,27.2,20.3,17,21.6,16.2,37.3],
    "Weight":       [4.36,4.054,2.56,2.3,2.83,3.14,2.795,3.41,2.13],
    "Drive_ratio":  [2.73,2.26,3.05,3.54,3.9,3.5,3.77,3.58,3.1],
    "Horsepower":   [155,142,95,97,103,125,115,133,69],
    "Displacement": [350,351,134,119,131,120,121,163,91],
    "Cylinders":    [8,8,4,4,5,6,4,6,4]
}

var colors = {
    "U.S.":    "#1f77b4",
    "Japan":   "#2ca02c",
    "Germany": "#ff7f0e",
    "Sweden":  "#8c564b",
    "France":  "#9467bd",
    "Italy":   "#e377c2"
}

var bars = [];

// the dimensions of our "paper"
var x = 10,
    y = 10,
    w = 900,
    h = 450;

function init() {

    // define the "paper", or canvas, however you wanna call it.
    var paper = Raphael(x, y, w, h);

    // create the bars
    _.each(data.Country, function(country, index) {
        width = 20;
        height = data.Mpg[index] * 5;
        x_pos = 10 + index*30;
        y_pos = h - 250 - height;
        var bar = paper.rect(x_pos, y_pos, width, height);

        // set a color
        bar.attr("fill", colors[country])
           .click(animate_bars);

        car = data.Car[index];
        
        // add the label
        var label = paper.text(x_pos + width/2, h - 240, car);
        label.rotate(-90)
            .attr("text-anchor", "end")
            .attr("font", "16px Helvetica");

        // add bar to an array
        bars.push(bar);
    });
    
}

function animate_bars() {
    _.each(bars, function(bar, index) {
        height = data.Weight[index] * 35
        bar.animate({
            "height": height,
            "y": h - 250 - height
        }, 1000);
    });
}
